diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-rrc.cc ns-3.39/src/lte/model/lte-ue-rrc.cc
--- ns-3.38/src/lte/model/lte-ue-rrc.cc	2023-03-16 20:54:23.776869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-rrc.cc	2023-07-05 14:23:48.017428200 -0700
@@ -25,14 +25,16 @@
 
 #include "lte-ue-rrc.h"
 
+#include "lte-common.h"
+#include "lte-pdcp.h"
+#include "lte-radio-bearer-info.h"
+#include "lte-rlc-am.h"
+#include "lte-rlc-tm.h"
+#include "lte-rlc-um.h"
+#include "lte-rlc.h"
+
 #include <ns3/fatal-error.h>
 #include <ns3/log.h>
-#include <ns3/lte-pdcp.h>
-#include <ns3/lte-radio-bearer-info.h>
-#include <ns3/lte-rlc-am.h>
-#include <ns3/lte-rlc-tm.h>
-#include <ns3/lte-rlc-um.h>
-#include <ns3/lte-rlc.h>
 #include <ns3/object-factory.h>
 #include <ns3/object-map.h>
 #include <ns3/simulator.h>
@@ -1307,7 +1309,7 @@
         uint32_t cellCsgId = m_lastSib1.cellAccessRelatedInfo.csgIdentity;
         bool cellCsgIndication = m_lastSib1.cellAccessRelatedInfo.csgIndication;
 
-        isSuitableCell = (cellCsgIndication == false) || (cellCsgId == m_csgWhiteList);
+        isSuitableCell = (!cellCsgIndication || cellCsgId == m_csgWhiteList);
 
         NS_LOG_LOGIC(this << " csg(ue/cell/indication)=" << m_csgWhiteList << "/" << cellCsgId
                           << "/" << cellCsgIndication);
@@ -1415,7 +1417,7 @@
 LteUeRrc::ApplyRadioResourceConfigDedicated(LteRrcSap::RadioResourceConfigDedicated rrcd)
 {
     NS_LOG_FUNCTION(this);
-    const struct LteRrcSap::PhysicalConfigDedicated& pcd = rrcd.physicalConfigDedicated;
+    const LteRrcSap::PhysicalConfigDedicated& pcd = rrcd.physicalConfigDedicated;
 
     if (pcd.haveAntennaInfoDedicated)
     {
@@ -1473,7 +1475,7 @@
             m_srb1->m_logicalChannelConfig.logicalChannelGroup =
                 stamIt->logicalChannelConfig.logicalChannelGroup;
 
-            struct LteUeCmacSapProvider::LogicalChannelConfig lcConfig;
+            LteUeCmacSapProvider::LogicalChannelConfig lcConfig;
             lcConfig.priority = stamIt->logicalChannelConfig.priority;
             lcConfig.prioritizedBitRateKbps = stamIt->logicalChannelConfig.prioritizedBitRateKbps;
             lcConfig.bucketSizeDurationMs = stamIt->logicalChannelConfig.bucketSizeDurationMs;
@@ -1567,7 +1569,7 @@
 
             m_drbCreatedTrace(m_imsi, m_cellId, m_rnti, dtamIt->drbIdentity);
 
-            struct LteUeCmacSapProvider::LogicalChannelConfig lcConfig;
+            LteUeCmacSapProvider::LogicalChannelConfig lcConfig;
             lcConfig.priority = dtamIt->logicalChannelConfig.priority;
             lcConfig.prioritizedBitRateKbps = dtamIt->logicalChannelConfig.prioritizedBitRateKbps;
             lcConfig.bucketSizeDurationMs = dtamIt->logicalChannelConfig.bucketSizeDurationMs;
@@ -3374,7 +3376,7 @@
         {
             NS_LOG_INFO("t310 started");
         }
-        m_cphySapProvider.at(0)->StartInSnycDetection();
+        m_cphySapProvider.at(0)->StartInSyncDetection();
         m_noOfSyncIndications = 0;
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ue-rrc.h ns-3.39/src/lte/model/lte-ue-rrc.h
--- ns-3.38/src/lte/model/lte-ue-rrc.h	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/lte-ue-rrc.h	2023-07-05 14:23:48.017428200 -0700
@@ -26,13 +26,13 @@
 #ifndef LTE_UE_RRC_H
 #define LTE_UE_RRC_H
 
-#include "ns3/component-carrier-ue.h"
-#include <ns3/lte-as-sap.h>
-#include <ns3/lte-pdcp-sap.h>
-#include <ns3/lte-rrc-sap.h>
-#include <ns3/lte-ue-ccm-rrc-sap.h>
-#include <ns3/lte-ue-cmac-sap.h>
-#include <ns3/lte-ue-cphy-sap.h>
+#include "lte-as-sap.h"
+#include "lte-pdcp-sap.h"
+#include "lte-rrc-sap.h"
+#include "lte-ue-ccm-rrc-sap.h"
+#include "lte-ue-cmac-sap.h"
+#include "lte-ue-cphy-sap.h"
+
 #include <ns3/object.h>
 #include <ns3/packet.h>
 #include <ns3/traced-callback.h>
@@ -41,9 +41,6 @@
 #include <set>
 #include <vector>
 
-#define MIN_NO_CC 1
-#define MAX_NO_CC 5 // this is the maximum number of carrier components allowed by 3GPP up to R13
-
 namespace ns3
 {
 
@@ -347,7 +344,7 @@
     typedef void (*ImsiCidRntiTracedCallback)(uint64_t imsi, uint16_t cellId, uint16_t rnti);
 
     /**
-     * TracedCallback signature for MIBRecieved, Sib1Received and
+     * TracedCallback signature for MIBReceived, Sib1Received and
      * HandoverStart events.
      *
      * \param [in] imsi
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-vendor-specific-parameters.cc ns-3.39/src/lte/model/lte-vendor-specific-parameters.cc
--- ns-3.38/src/lte/model/lte-vendor-specific-parameters.cc	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/lte-vendor-specific-parameters.cc	2023-07-05 14:23:48.017428200 -0700
@@ -17,8 +17,9 @@
  * Author: Marco Miozzo  <marco.miozzo@cttc.es>
  */
 
+#include "lte-vendor-specific-parameters.h"
+
 #include <ns3/log.h>
-#include <ns3/lte-vendor-specific-parameters.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-vendor-specific-parameters.h ns-3.39/src/lte/model/lte-vendor-specific-parameters.h
--- ns-3.38/src/lte/model/lte-vendor-specific-parameters.h	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/lte-vendor-specific-parameters.h	2023-07-05 14:23:48.017428200 -0700
@@ -20,7 +20,7 @@
 #ifndef LTE_VENDOR_SPECIFIC_PARAMETERS
 #define LTE_VENDOR_SPECIFIC_PARAMETERS
 
-#include <ns3/ff-mac-common.h>
+#include "ff-mac-common.h"
 
 #define SRS_CQI_RNTI_VSP 1
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/no-op-component-carrier-manager.cc ns-3.39/src/lte/model/no-op-component-carrier-manager.cc
--- ns-3.38/src/lte/model/no-op-component-carrier-manager.cc	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/no-op-component-carrier-manager.cc	2023-07-05 14:23:48.017428200 -0700
@@ -22,6 +22,8 @@
 
 #include "no-op-component-carrier-manager.h"
 
+#include "lte-common.h"
+
 #include <ns3/log.h>
 #include <ns3/random-variable-stream.h>
 
@@ -205,7 +207,7 @@
         lci.qci = bearer.qci;
         if (ncc == 0)
         {
-            lci.isGbr = bearer.IsGbr();
+            lci.resourceType = bearer.GetResourceType();
             lci.mbrUl = bearer.gbrQosInfo.mbrUl;
             lci.mbrDl = bearer.gbrQosInfo.mbrDl;
             lci.gbrUl = bearer.gbrQosInfo.gbrUl;
@@ -213,7 +215,7 @@
         }
         else
         {
-            lci.isGbr = 0;
+            lci.resourceType = 0;
             lci.mbrUl = 0;
             lci.mbrDl = 0;
             lci.gbrUl = 0;
@@ -234,7 +236,7 @@
         lcinfo.lcId = lcid;
         lcinfo.lcGroup = lcGroup;
         lcinfo.qci = bearer.qci;
-        lcinfo.isGbr = bearer.IsGbr();
+        lcinfo.resourceType = bearer.GetResourceType();
         lcinfo.mbrUl = bearer.gbrQosInfo.mbrUl;
         lcinfo.mbrDl = bearer.gbrQosInfo.mbrDl;
         lcinfo.gbrUl = bearer.gbrQosInfo.gbrUl;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/no-op-component-carrier-manager.h ns-3.39/src/lte/model/no-op-component-carrier-manager.h
--- ns-3.38/src/lte/model/no-op-component-carrier-manager.h	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/no-op-component-carrier-manager.h	2023-07-05 14:23:48.017428200 -0700
@@ -22,9 +22,9 @@
 #ifndef NO_OP_COMPONENT_CARRIER_MANAGER_H
 #define NO_OP_COMPONENT_CARRIER_MANAGER_H
 
-#include <ns3/lte-ccm-rrc-sap.h>
-#include <ns3/lte-enb-component-carrier-manager.h>
-#include <ns3/lte-rrc-sap.h>
+#include "lte-ccm-rrc-sap.h"
+#include "lte-enb-component-carrier-manager.h"
+#include "lte-rrc-sap.h"
 
 #include <map>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/no-op-handover-algorithm.h ns-3.39/src/lte/model/no-op-handover-algorithm.h
--- ns-3.38/src/lte/model/no-op-handover-algorithm.h	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/no-op-handover-algorithm.h	2023-07-05 14:23:48.017428200 -0700
@@ -21,9 +21,9 @@
 #ifndef NO_OP_HANDOVER_ALGORITHM_H
 #define NO_OP_HANDOVER_ALGORITHM_H
 
-#include <ns3/lte-handover-algorithm.h>
-#include <ns3/lte-handover-management-sap.h>
-#include <ns3/lte-rrc-sap.h>
+#include "lte-handover-algorithm.h"
+#include "lte-handover-management-sap.h"
+#include "lte-rrc-sap.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/pf-ff-mac-scheduler.cc ns-3.39/src/lte/model/pf-ff-mac-scheduler.cc
--- ns-3.38/src/lte/model/pf-ff-mac-scheduler.cc	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/pf-ff-mac-scheduler.cc	2023-07-05 14:23:48.017428200 -0700
@@ -17,12 +17,14 @@
  * Author: Marco Miozzo <marco.miozzo@cttc.es>
  */
 
+#include "pf-ff-mac-scheduler.h"
+
+#include "lte-amc.h"
+#include "lte-vendor-specific-parameters.h"
+
 #include <ns3/boolean.h>
 #include <ns3/log.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-vendor-specific-parameters.h>
 #include <ns3/math.h>
-#include <ns3/pf-ff-mac-scheduler.h>
 #include <ns3/pointer.h>
 #include <ns3/simulator.h>
 
@@ -142,7 +144,7 @@
 
 void
 PfFfMacScheduler::DoCschedCellConfigReq(
-    const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedCellConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     // Read the subset of parameters used
@@ -155,7 +157,7 @@
 
 void
 PfFfMacScheduler::DoCschedUeConfigReq(
-    const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedUeConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " RNTI " << params.m_rnti << " txMode "
                          << (uint16_t)params.m_transmissionMode);
@@ -201,7 +203,7 @@
 
 void
 PfFfMacScheduler::DoCschedLcConfigReq(
-    const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params)
+    const FfMacCschedSapProvider::CschedLcConfigReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " New LC, rnti: " << params.m_rnti);
 
@@ -230,7 +232,7 @@
 
 void
 PfFfMacScheduler::DoCschedLcReleaseReq(
-    const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params)
+    const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     for (std::size_t i = 0; i < params.m_logicalChannelIdentity.size(); i++)
@@ -257,7 +259,7 @@
 
 void
 PfFfMacScheduler::DoCschedUeReleaseReq(
-    const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params)
+    const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -297,7 +299,7 @@
 
 void
 PfFfMacScheduler::DoSchedDlRlcBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this << params.m_rnti << (uint32_t)params.m_logicalChannelIdentity);
     // API generated by RLC for updating RLC parameters on a LC (tx and retx queues)
@@ -322,7 +324,7 @@
 
 void
 PfFfMacScheduler::DoSchedDlPagingBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_FATAL_ERROR("method not implemented");
@@ -330,7 +332,7 @@
 
 void
 PfFfMacScheduler::DoSchedDlMacBufferReq(
-    const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_FATAL_ERROR("method not implemented");
@@ -392,14 +394,8 @@
     {
         i = (i + 1) % HARQ_PROC_NUM;
     } while (((*itStat).second.at(i) != 0) && (i != (*it).second));
-    if ((*itStat).second.at(i) == 0)
-    {
-        return (true);
-    }
-    else
-    {
-        return (false); // return a not valid harq proc id
-    }
+
+    return (*itStat).second.at(i) == 0;
 }
 
 uint8_t
@@ -407,7 +403,7 @@
 {
     NS_LOG_FUNCTION(this << rnti);
 
-    if (m_harqOn == false)
+    if (!m_harqOn)
     {
         return (0);
     }
@@ -478,7 +474,7 @@
 
 void
 PfFfMacScheduler::DoSchedDlTriggerReq(
-    const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " Frame no. " << (params.m_sfnSf >> 4) << " subframe no. "
                          << (0xF & params.m_sfnSf));
@@ -501,7 +497,7 @@
     rbgMap = m_ffrSapProvider->GetAvailableDlRbg();
     for (std::vector<bool>::iterator it = rbgMap.begin(); it != rbgMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             rbgAllocatedNum++;
         }
@@ -529,7 +525,7 @@
 
     for (std::vector<bool>::iterator it = ulRbMap.begin(); it != ulRbMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             if (tmpMinBandwidth > maxContinuousUlBandwidth)
             {
@@ -558,7 +554,7 @@
     m_rachAllocationMap.resize(m_cschedCellConfig.m_ulBandwidth, 0);
     uint16_t rbStart = 0;
     rbStart = ffrRbStartOffset;
-    std::vector<struct RachListElement_s>::iterator itRach;
+    std::vector<RachListElement_s>::iterator itRach;
     for (itRach = m_rachList.begin(); itRach != m_rachList.end(); itRach++)
     {
         NS_ASSERT_MSG(m_amc->GetUlTbSizeFromMcs(m_ulGrantMcs, m_cschedCellConfig.m_ulBandwidth) >
@@ -600,7 +596,7 @@
             m_rachAllocationMap.at(i) = (*itRach).m_rnti;
         }
 
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             // generate UL-DCI for HARQ retransmissions
             UlDciListElement_s uldci;
@@ -665,12 +661,12 @@
             m_dlInfoListBuffered = params.m_dlInfoList;
         }
     }
-    if (m_harqOn == false)
+    if (!m_harqOn)
     {
         // Ignore HARQ feedback
         m_dlInfoListBuffered.clear();
     }
-    std::vector<struct DlInfoListElement_s> dlInfoListUntxed;
+    std::vector<DlInfoListElement_s> dlInfoListUntxed;
     for (std::size_t i = 0; i < m_dlInfoListBuffered.size(); i++)
     {
         std::set<uint16_t>::iterator itRnti = rntiAllocated.find(m_dlInfoListBuffered.at(i).m_rnti);
@@ -761,7 +757,7 @@
             bool free = true;
             for (std::size_t j = 0; j < dciRbg.size(); j++)
             {
-                if (rbgMap.at(dciRbg.at(j)) == true)
+                if (rbgMap.at(dciRbg.at(j)))
                 {
                     free = false;
                     break;
@@ -789,7 +785,7 @@
                 std::vector<bool> rbgMapCopy = rbgMap;
                 while ((j < dciRbg.size()) && (startRbg != rbgId))
                 {
-                    if (rbgMapCopy.at(rbgId) == false)
+                    if (!rbgMapCopy.at(rbgId))
                     {
                         rbgMapCopy.at(rbgId) = true;
                         dciRbg.at(j) = rbgId;
@@ -860,7 +856,7 @@
             }
             for (std::size_t k = 0; k < (*itRlcPdu).second.at(0).at(dci.m_harqProcess).size(); k++)
             {
-                std::vector<struct RlcPduListElement_s> rlcPduListPerLc;
+                std::vector<RlcPduListElement_s> rlcPduListPerLc;
                 for (std::size_t j = 0; j < nLayers; j++)
                 {
                     if (retx.at(j))
@@ -948,20 +944,20 @@
     for (int i = 0; i < rbgNum; i++)
     {
         NS_LOG_INFO(this << " ALLOCATION for RBG " << i << " of " << rbgNum);
-        if (rbgMap.at(i) == false)
+        if (!rbgMap.at(i))
         {
             std::map<uint16_t, pfsFlowPerf_t>::iterator it;
             std::map<uint16_t, pfsFlowPerf_t>::iterator itMax = m_flowStatsDl.end();
             double rcqiMax = 0.0;
             for (it = m_flowStatsDl.begin(); it != m_flowStatsDl.end(); it++)
             {
-                if ((m_ffrSapProvider->IsDlRbgAvailableForUe(i, (*it).first)) == false)
+                if (!m_ffrSapProvider->IsDlRbgAvailableForUe(i, (*it).first))
                 {
                     continue;
                 }
 
                 std::set<uint16_t>::iterator itRnti = rntiAllocated.find((*it).first);
-                if ((itRnti != rntiAllocated.end()) || (!HarqProcessAvailability((*it).first)))
+                if (itRnti != rntiAllocated.end() || !HarqProcessAvailability((*it).first))
                 {
                     // UE already allocated for HARQ or without HARQ process available -> drop it
                     if (itRnti != rntiAllocated.end())
@@ -1194,7 +1190,7 @@
                  ((*itBufReq).second.m_rlcRetransmissionQueueSize > 0) ||
                  ((*itBufReq).second.m_rlcStatusPduSize > 0)))
             {
-                std::vector<struct RlcPduListElement_s> newRlcPduLe;
+                std::vector<RlcPduListElement_s> newRlcPduLe;
                 for (uint8_t j = 0; j < nLayer; j++)
                 {
                     RlcPduListElement_s newRlcEl;
@@ -1206,7 +1202,7 @@
                     UpdateDlRlcBufferInfo(newDci.m_rnti,
                                           newRlcEl.m_logicalChannelIdentity,
                                           newRlcEl.m_size);
-                    if (m_harqOn == true)
+                    if (m_harqOn)
                     {
                         // store RLC PDU list for HARQ
                         std::map<uint16_t, DlHarqRlcPduListBuffer_t>::iterator itRlcPdu =
@@ -1236,7 +1232,7 @@
 
         newEl.m_dci = newDci;
 
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             // store DCI for HARQ
             std::map<uint16_t, DlHarqProcessesDciBuffer_t>::iterator itDci =
@@ -1297,7 +1293,7 @@
 
 void
 PfFfMacScheduler::DoSchedDlRachInfoReq(
-    const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -1306,7 +1302,7 @@
 
 void
 PfFfMacScheduler::DoSchedDlCqiInfoReq(
-    const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     m_ffrSapProvider->ReportDlCqiInfo(params);
@@ -1401,7 +1397,7 @@
 
 void
 PfFfMacScheduler::DoSchedUlTriggerReq(
-    const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params)
 {
     NS_LOG_FUNCTION(this << " UL - Frame no. " << (params.m_sfnSf >> 4) << " subframe no. "
                          << (0xF & params.m_sfnSf) << " size " << params.m_ulInfoList.size());
@@ -1426,7 +1422,7 @@
 
     for (std::vector<bool>::iterator it = rbMap.begin(); it != rbMap.end(); it++)
     {
-        if ((*it) == true)
+        if (*it)
         {
             rbAllocatedNum++;
         }
@@ -1445,7 +1441,7 @@
         }
     }
 
-    if (m_harqOn == true)
+    if (m_harqOn)
     {
         //   Process UL HARQ feedback
 
@@ -1486,7 +1482,7 @@
                 bool free = true;
                 for (int j = dci.m_rbStart; j < dci.m_rbStart + dci.m_rbLen; j++)
                 {
-                    if (rbMap.at(j) == true)
+                    if (rbMap.at(j))
                     {
                         free = false;
                         NS_LOG_INFO(this << " BUSY " << j);
@@ -1627,12 +1623,12 @@
             bool free = true;
             for (int j = rbAllocated; j < rbAllocated + rbPerFlow; j++)
             {
-                if (rbMap.at(j) == true)
+                if (rbMap.at(j))
                 {
                     free = false;
                     break;
                 }
-                if ((m_ffrSapProvider->IsUlRbgAvailableForUe(j, (*it).first)) == false)
+                if (!m_ffrSapProvider->IsUlRbgAvailableForUe(j, (*it).first))
                 {
                     free = false;
                     break;
@@ -1749,7 +1745,7 @@
         ret.m_dciList.push_back(uldci);
         // store DCI for HARQ_PERIOD
         uint8_t harqId = 0;
-        if (m_harqOn == true)
+        if (m_harqOn)
         {
             std::map<uint16_t, uint8_t>::iterator itProcId;
             itProcId = m_ulHarqCurrentProcessId.find(uldci.m_rnti);
@@ -1829,21 +1825,21 @@
 
 void
 PfFfMacScheduler::DoSchedUlNoiseInterferenceReq(
-    const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 }
 
 void
 PfFfMacScheduler::DoSchedUlSrInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 }
 
 void
 PfFfMacScheduler::DoSchedUlMacCtrlInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
 
@@ -1886,7 +1882,7 @@
 
 void
 PfFfMacScheduler::DoSchedUlCqiInfoReq(
-    const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     m_ffrSapProvider->ReportUlCqiInfo(params);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/pf-ff-mac-scheduler.h ns-3.39/src/lte/model/pf-ff-mac-scheduler.h
--- ns-3.38/src/lte/model/pf-ff-mac-scheduler.h	2023-03-16 20:54:23.780869000 -0700
+++ ns-3.39/src/lte/model/pf-ff-mac-scheduler.h	2023-07-05 14:23:48.017428200 -0700
@@ -20,37 +20,21 @@
 #ifndef PF_FF_MAC_SCHEDULER_H
 #define PF_FF_MAC_SCHEDULER_H
 
-#include <ns3/ff-mac-csched-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/ff-mac-scheduler.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-ffr-sap.h>
+#include "ff-mac-csched-sap.h"
+#include "ff-mac-sched-sap.h"
+#include "ff-mac-scheduler.h"
+#include "lte-amc.h"
+#include "lte-common.h"
+#include "lte-ffr-sap.h"
+
 #include <ns3/nstime.h>
 
 #include <map>
 #include <vector>
 
-// value for SINR outside the range defined by FF-API, used to indicate that there
-// is no CQI for this element
-#define NO_SINR -5000
-
-#define HARQ_PROC_NUM 8
-#define HARQ_DL_TIMEOUT 11
-
 namespace ns3
 {
 
-typedef std::vector<uint8_t> DlHarqProcessesStatus_t;
-typedef std::vector<uint8_t> DlHarqProcessesTimer_t;
-typedef std::vector<DlDciListElement_s> DlHarqProcessesDciBuffer_t;
-typedef std::vector<std::vector<struct RlcPduListElement_s>>
-    RlcPduList_t;                                           // vector of the LCs and layers per UE
-typedef std::vector<RlcPduList_t> DlHarqRlcPduListBuffer_t; // vector of the 8 HARQ processes per UE
-
-typedef std::vector<UlDciListElement_s> UlHarqProcessesDciBuffer_t;
-typedef std::vector<uint8_t> UlHarqProcessesStatus_t;
-
 /// pfsFlowPerf_t structure
 struct pfsFlowPerf_t
 {
@@ -124,40 +108,35 @@
      *
      * \param params FfMacCschedSapProvider::CschedCellConfigReqParameters
      */
-    void DoCschedCellConfigReq(
-        const struct FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
+    void DoCschedCellConfigReq(const FfMacCschedSapProvider::CschedCellConfigReqParameters& params);
 
     /**
      * \brief CSched UE config request
      *
      * \param params FfMacCschedSapProvider::CschedUeConfigReqParameters
      */
-    void DoCschedUeConfigReq(
-        const struct FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
+    void DoCschedUeConfigReq(const FfMacCschedSapProvider::CschedUeConfigReqParameters& params);
 
     /**
      * \brief CSched LC config request
      *
      * \param params FfMacCschedSapProvider::CschedLcConfigReqParameters
      */
-    void DoCschedLcConfigReq(
-        const struct FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
+    void DoCschedLcConfigReq(const FfMacCschedSapProvider::CschedLcConfigReqParameters& params);
 
     /**
      * \brief CSched LC release request
      *
      * \param params FfMacCschedSapProvider::CschedLcReleaseReqParameters
      */
-    void DoCschedLcReleaseReq(
-        const struct FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
+    void DoCschedLcReleaseReq(const FfMacCschedSapProvider::CschedLcReleaseReqParameters& params);
 
     /**
      * \brief CSched UE release request
      *
      * \param params FfMacCschedSapProvider::CschedLcReleaseReqParameters
      */
-    void DoCschedUeReleaseReq(
-        const struct FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
+    void DoCschedUeReleaseReq(const FfMacCschedSapProvider::CschedUeReleaseReqParameters& params);
 
     //
     // Implementation of the SCHED API primitives
@@ -169,8 +148,7 @@
      *
      * \param params FfMacSchedSapProvider::SchedDlRlcBufferReqParameters
      */
-    void DoSchedDlRlcBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
+    void DoSchedDlRlcBufferReq(const FfMacSchedSapProvider::SchedDlRlcBufferReqParameters& params);
 
     /**
      * \brief Sched DL paging buffer request
@@ -178,47 +156,42 @@
      * \param params FfMacSchedSapProvider::SchedDlPagingBufferReqParameters
      */
     void DoSchedDlPagingBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
+        const FfMacSchedSapProvider::SchedDlPagingBufferReqParameters& params);
 
     /**
      * \brief Sched DL MAC buffer request
      *
      * \param params FfMacSchedSapProvider::SchedDlMacBufferReqParameters
      */
-    void DoSchedDlMacBufferReq(
-        const struct FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
+    void DoSchedDlMacBufferReq(const FfMacSchedSapProvider::SchedDlMacBufferReqParameters& params);
 
     /**
      * \brief Sched DL trigger request
      *
      * \param params FfMacSchedSapProvider::SchedDlTriggerReqParameters
      */
-    void DoSchedDlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
+    void DoSchedDlTriggerReq(const FfMacSchedSapProvider::SchedDlTriggerReqParameters& params);
 
     /**
      * \brief Sched DL RACH info request
      *
      * \param params FfMacSchedSapProvider::SchedDlRachInfoReqParameters
      */
-    void DoSchedDlRachInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
+    void DoSchedDlRachInfoReq(const FfMacSchedSapProvider::SchedDlRachInfoReqParameters& params);
 
     /**
      * \brief Sched DL CQI info request
      *
      * \param params FfMacSchedSapProvider::SchedDlCqiInfoReqParameters
      */
-    void DoSchedDlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
+    void DoSchedDlCqiInfoReq(const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params);
 
     /**
      * \brief Sched UL trigger request
      *
      * \param params FfMacSchedSapProvider::SchedUlTriggerReqParameters
      */
-    void DoSchedUlTriggerReq(
-        const struct FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
+    void DoSchedUlTriggerReq(const FfMacSchedSapProvider::SchedUlTriggerReqParameters& params);
 
     /**
      * \brief Sched UL noise interference request
@@ -226,14 +199,14 @@
      * \param params FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters
      */
     void DoSchedUlNoiseInterferenceReq(
-        const struct FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlNoiseInterferenceReqParameters& params);
 
     /**
      * \brief Sched UL SR info request
      *
      * \param params FfMacSchedSapProvider::SchedUlSrInfoReqParameters
      */
-    void DoSchedUlSrInfoReq(const struct FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
+    void DoSchedUlSrInfoReq(const FfMacSchedSapProvider::SchedUlSrInfoReqParameters& params);
 
     /**
      * \brief Sched UL MAC control info request
@@ -241,15 +214,14 @@
      * \param params FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters
      */
     void DoSchedUlMacCtrlInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
+        const FfMacSchedSapProvider::SchedUlMacCtrlInfoReqParameters& params);
 
     /**
      * \brief Sched UL CQI info request
      *
      * \param params FfMacSchedSapProvider::SchedUlCqiInfoReqParameters
      */
-    void DoSchedUlCqiInfoReq(
-        const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
+    void DoSchedUlCqiInfoReq(const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params);
 
     /**
      * \brief Get RBG size
@@ -422,9 +394,9 @@
         m_ulHarqProcessesDciBuffer; ///< UL HARQ process DCI buffer
 
     // RACH attributes
-    std::vector<struct RachListElement_s> m_rachList; ///< RACH list
-    std::vector<uint16_t> m_rachAllocationMap;        ///< RACH allocation map
-    uint8_t m_ulGrantMcs;                             ///< MCS for UL grant (default 0)
+    std::vector<RachListElement_s> m_rachList; ///< RACH list
+    std::vector<uint16_t> m_rachAllocationMap; ///< RACH allocation map
+    uint8_t m_ulGrantMcs;                      ///< MCS for UL grant (default 0)
 };
 
 } // namespace ns3
